Extlinux fallback

If GRUB2 is not available in the system a fallback to install Extlinux
will happen. This patch also allows you to enforce the use of Extlinux
exporting the DIB_EXTLINUX variable.

Change-Id: I88fa792a0bd19cacca167134f2054b11c807a451
This commit is contained in:
Lucas Alvares Gomes 2013-08-27 11:00:03 +01:00
parent b01f412c1e
commit 5dd6c4a834
3 changed files with 151 additions and 91 deletions

View File

@ -49,6 +49,7 @@ package_map = {
'openssh-client': 'openssh-clients',
'qpidd': 'qpid-cpp-server',
'qpid-client': 'qpid-cpp-client',
'extlinux': 'syslinux-extlinux',
}
for arg in sys.argv[1:]:

View File

@ -1,5 +1,7 @@
Sets up a partitioned disk (rather than building just one filesystem with no
partition table).
The disk will have grub[2]-install run on it, and that assumes a functional
grub[2] setup.
By default the disk will have grub[2]-install run on it, in case GRUB2
is not available in the system a fallback to Extlinux will happen. It's
also possible to enforce the use of Extlinux exporting a DIB_EXTLINUX
varible to the environment.

View File

@ -6,6 +6,53 @@
set -e
set -x
# FIXME:
[ -n "$IMAGE_BLOCK_DEVICE" ]
PART_DEV=$IMAGE_BLOCK_DEVICE
BOOT_DEV=$(echo $IMAGE_BLOCK_DEVICE | sed -e 's#p1##' | sed -e 's#mapper/##')
function install_extlinux {
install-packages extlinux
echo "Installing Extlinux..."
MBR=/usr/share/syslinux/mbr.bin
if [ ! -f $MBR ]; then
MBR=/usr/lib/syslinux/mbr.bin
if [ ! -f $MBR ]; then
echo "mbr.bin (from SYSLINUX) not found."
exit 1
fi
fi
dd if=$MBR of=$BOOT_DEV
mkdir -p /boot/syslinux
extlinux --install /boot/syslinux
if [ -f /etc/redhat-release ]; then
kernel=$(ls -1rv /boot/vmlinuz* | head -1)
initrd=$(ls -1rv /boot/initramfs* | head -1)
elif [ -f /etc/debian_version ]; then
kernel=$(ls -1rv /boot/vmlinuz*generic | head -1)
initrd=$(ls -1rv /boot/initrd*generic | head -1)
else
echo "Unable to find kernel and initram"
exit 1
fi
cat > /boot/syslinux/syslinux.cfg<<_EOF_
DEFAULT linux
LABEL linux
KERNEL $kernel
APPEND rw root=LABEL=cloudimg-rootfs
INITRD $initrd
_EOF_
}
function install_grub2 {
install-packages grub-pc
# XXX: grub-probe on the nbd0/loop0 device returns nothing - workaround, manually
@ -14,14 +61,16 @@ GRUBNAME=`which grub-install` || echo "trying grub2-install"
if [ -z "$GRUBNAME" ]; then
GRUBNAME="bash -x `which grub2-install`"
fi
if [ -z "$GRUBNAME" ]; then
echo "NO grub-install or grub2-install found"
exit 1
# If no GRUB2 is found, fallback to extlinux
if [ -z "$GRUBNAME" ] || [ $($GRUBNAME --version | grep "0.97" | wc -l) -ne 0 ]; then
echo "No GRUB2 found. Fallback to Extlinux..."
install_extlinux
exit 0
fi
# FIXME:
[ -n "$IMAGE_BLOCK_DEVICE" ]
PART_DEV=$IMAGE_BLOCK_DEVICE
BOOT_DEV=$(echo $IMAGE_BLOCK_DEVICE | sed -e 's/p1//')
echo "Installing GRUB2..."
GRUB_OPTS=${GRUB_OPTS:""}
# XXX: This is buggy:
# - --target=i386-pc is invalid for non-i386/amd64 architectures
@ -104,3 +153,11 @@ if [ $DIST = 'Fedora' ] ; then
sed -i "s%UUID=[A-Za-z0-9\-]*%LABEL=cloudimg-rootfs%" /etc/fstab
fi
fi
}
DIB_EXTLINUX=${DIB_EXTLINUX:-0}
if [ "$DIB_EXTLINUX" != "0" ]; then
install_extlinux
else
install_grub2
fi